#include <stdio.h>

#include "srcguru.h"

#include "hash.h"

hash_item** new_hash_table(int size)
{
    hash_item** x;
    int y;
    x = (hash_item **) malloc(sizeof(hash_item *) * HT_SIZE);
    for (y = 0; y < HT_SIZE; y++)
        x[y] = NULL;
    return x;
}

int hash_value(char* name)
{
    int n = 0;
    while (*name)
       n = n + (*name++ & 31);
    return (n % HT_SIZE);
}

void hash_add(int type, char* name, char* value, void* misc, hash_item** ht)
{
    hash_item* z;
    int x;
    
    x = hash_value(name);

    z = (hash_item *) malloc(sizeof(hash_item));
    z->type = type;
    z->name = (char *) malloc(strlen(name) + 1);
    strcpy(z->name, name);
    z->value = (char *) malloc(strlen(value) + 1);
    z->misc = misc;
    strcpy(z->value, value);

    z->next = ht[x];
    ht[x] = z;
}

hash_item* hash_get(char* name, hash_item** ht)
{
    int x;
    hash_item** y;

    x = hash_value(name);
    y = ht + x;
    while ((*y)) {
        if (eqc((*y)->name, name))
            return (*y);
        y = &((*y)->next);
    }
    return NULL;
}
