***************************** TI-85 SIMULATION LIBRARY
* ti85lib2@0000 - initialization function, A5->8K buffer, A6->program
* ti85lib2@0001 - "halt" instruction
* ti85lib2@0002 - CLEARLCD call simulator
* ti85lib2@0003 - OTH_PAUSE call simulator
* ti85lib2@0004 - TX_CHARPUT call simulator
* ti85lib2@0005 - D_ZT_STR call simulator
* ti85lib2@0006 - GET_KEY call simulator
* ti85lib2@0007 - "out" instruction, D1 = port number
* ti85lib2@0008 - "in" instruction, D1 = port number
* ti85lib2@0009 - FIND_PIXEL call simulator
* ti85lib2@000A - LD_HL_MHL call simulator
* ti85lib2@000B - D_LM_STR call simulator
* ti85lib2@000C - M_CHARPUT call simulator
* ti85lib2@000D - "ld a, r" instruction
* ti85lib2@000E - D_ZM_STR call simulator
* ti85lib2@000F - UNPACK_HL call simulator
* ti85lib2@0010 - CP_HL_DE call simulator
* ti85lib2@0011 - D_HL_DECI call simulator
* ti85lib2@0012 - OTH_EXIT call simulator
* ti85lib2@0013 - OTH_ARROW call simulator
* ti85lib2@0014 - OTH_CLEAR call simulator
* ti85lib2@0015 - UNPACK_HL+2 call simulator
* ti85lib2@0016 - "ldir" instruction
* ti85lib2@0017 - "lddr" instruction

        XDEF    _library

    IFD FARGO
        INCLUDE "tios.h"
    ENDIF

    IFD TI92P
    IFND TI89
        XDEF    _ti92plus
    ENDIF
    IFD TI89
        XDEF    _ti89
    ENDIF
        INCLUDE "doorsos.h"
        INCLUDE "userlib.h"
tios::FontSetSys    equ doorsos::FontSetSys
tios::DrawStrXY     equ doorsos::DrawStrXY
tios::kb_vars       equ doorsos::kb_vars
tios::sprintf       equ doorsos::sprintf
    ENDIF

    IFD MEMSLOW
ENTRY   MACRO
ti85lib2@\1:
        XDEF    ti85lib2@\1
        ENDM
    ENDIF

    IFD MEMFAST
ENTRY   MACRO
ti85lib3@\1:
        XDEF    ti85lib3@\1
        ENDM
    ENDIF
                    
    IFD MEMSLOW
__ADDR  MACRO

    IFNE    \1-1
        move.w  d\1,d1
    ENDIF

        sub.w   #$7000,d1
        bclr    #15,d1
        cmp.w   #$2000,d1
        blt.s   ib\@

        move.l  prog_code(pc),a\1
        bra.s   ip\@

ib\@:
        move.l  a0,a\1

ip\@:
        add.w   d1,a\1
        ENDM
    ENDIF

    IFD MEMFAST
__ADDR  MACRO
        lea     0(a0,d\1.w),a\1
        ENDM
    ENDIF

    IFD MEMSLOW
OFFF    equ 0
OFF8    equ $1000
    ENDIF

    IFD MEMFAST
OFFF    equ -$1000
OFF8    equ -$8000
    ENDIF

***************************** INITIALIZATION

        ENTRY   0000
        
        move.l  sp,exit+2
        bsr     Clear_Screen
    IFD MEMSLOW
        move.l  a4,data_buffer          ; Save buffer address
        move.l  a6,prog_code
        move.l  #(8192/4)-1,d0          ; Clear buffer
clb_loop:
        move.l  d1,(a4)+
        dbra    d0,clb_loop
    ENDIF
    IFD MEMFAST
        move.l  a6,data_buffer
        move.l  #(4096/4)-1,d0
clb_loop:
        move.l  d1,-(a6)
        move.l  d1,-$7000(a6)
        dbra    d0,clb_loop
    ENDIF

        move.w  #1,-(sp)                ; Set font to normal
        jsr     tios::FontSetSys
        addq.w  #2,sp

        move.w  #-6,d4                  ; Display warning message
        lea     warning+1(pc),a2
        bsr     Print_Messages

GetKey: move.l  keyboard,a3             ; Check for pressing '3'
        tst.w   (a3)                   
        beq.s   GetKey                
        clr.w   (a3)                
        move.w  2(a3),d0

        cmp.w   #51,d0
        beq.s   continue
        rts

continue:
        bsr     Clear_Screen            ; Clear the screen

        lea     -2048(sp),sp
        bsr     Initialize_Character_Buffer

        lea     $600000,a5              ; Install new interrupt
        bclr    #2,1(a5)
        move.l  $74,old_int5
        move.l  #new_int5,$74
        move.w  #$f9,$16(a5)

    IFD MEMSLOW
        move.l  prog_code,a6
        lea     $2000(a6),a6
        move.l  data_buffer,a0
    ENDIF
    IFD MEMFAST
        move.l  data_buffer,a0
        lea     -$7000(a0),a6
    ENDIF

find_start:                             ; Find start of program & run it
        tst.b   (a6)+
        bne.s   find_start
        move.l  a6,d0
        btst    #0,d0
        beq.s   ok
        addq.w  #1,a6
ok:
        move.w  #$8346,d6               ; Initial value of IY
        move.w  #$400,d0                ; Disable low-level interrupts
        trap    #1

        lea     tbuf,a1
        lea     OFFF+$C00(a0),a7

        tst.w   d7                 
        beq.s   noes
        move.w  d7,-(sp)
        jmp     (a6)

noes:   pea     OTH_EXIT(pc)
        jmp     (a6)

***************************** NEW TIMER INTERRUPT

new_int5:
        move.l  a0,-(sp)              
        lea     count1(pc),a0
        addq.w  #1,(a0)+                ; Inc/Test periodic action counters
        addq.w  #1,(a0)
        cmp.w   #2,(a0)
        beq.s   update_keys
        cmp.w   #4,(a0)
        bne.s   done

        clr.w   (a0)                    ; Redraw the screen
        movem.l d0-d4/a1,-(sp)
        lea     LCD_MEM+16+30,a0
        move.l  data_buffer,a1
        lea     OFFF+$c00(a1),a1
        moveq   #15,d4
screen_loop:
        movem.l (a1)+,d0-d3
        movem.l d0-d3,-(a0)
        lea     46(a0),a0
        movem.l (a1)+,d0-d3
        movem.l d0-d3,-(a0)
        lea     46(a0),a0
        movem.l (a1)+,d0-d3
        movem.l d0-d3,-(a0)
        lea     46(a0),a0
        movem.l (a1)+,d0-d3
        movem.l d0-d3,-(a0)
        lea     46(a0),a0
        dbra    d4,screen_loop
        movem.l (sp)+,d0-d4/a1

done:   move.l  (sp)+,a0
        rte

update_keys:
        movem.l d0-d2/a1-a2,-(sp)

        lea     key_data_new(pc),a0     ; Save old keyboard data
        lea     key_data_old(pc),a1
        move.l  (a0)+,(a1)+
        move.l  (a0)+,(a1)+
        move.w  (a0)+,(a1)+

        lea     $600018,a0              ; Read raw keyboard data
        lea     key_data_new(pc),a1
        moveq   #$FFFFFFFE,d1
        moveq   #9,d0
read_key_loop:
        move.w  d1,(a0)
        rol.w   #1,d1
        nop
        nop
        move.b  3(a0),(a1)+
        dbra    d0,read_key_loop

        lea     key_data_new(pc),a0     ; Scan for newly pressed keys
        lea     key_data_chg(pc),a2
        moveq   #9,d1
key_scan_loop:
        move.b  (a0)+,d0
        not.b   d0
        and.b   (a1)+,d0
        move.b  d0,(a2)+
        dbra    d1,key_scan_loop

        moveq   #0,d1
        moveq   #$38,d2
        lea     keyconvtable_end,a0
get_key_loop:
        move.b  -(a0),d1                ; D0 = (bit << 4) | row
        and.b   #$f,d1
        move.b  key_data_chg(pc,d1.w),d0
        move.b  (a0),d1
        lsr.w   #4,d1
        btst    d1,d0
        bne.s   keys_done
        subq.w  #1,d2
        bne.s   get_key_loop

keys_done:
        move.b  d2,key_read
        movem.l (sp)+,d0-d2/a1-a2
        bra.s   done
        
key_data_new:
        dc.w    0,0,0,0,0
key_data_old:
        dc.w    0,0,0,0,0
key_data_chg:
        dc.w    0,0,0,0,0

key_read:
        dc.w    0

***************************** HALT INSTRUCTION

        ENTRY   0001
        move.l  a1,-(sp)
        lea     count1,a1
        clr.w   (a1)
wait:   tst.w   (a1)
        beq.s   wait
        move.l  (sp)+,a1
        rts

***************************** CLEARLCD CALL SIMULATOR

        ENTRY   0002
        lea     OFFF+$c00(a0),a4
        move.w  #255,d0
        moveq   #0,d1
clll:   move.l  d1,(a4)+
        dbra    d0,clll
        moveq   #0,d3
        rts

***************************** OTH_PAUSE CALL SIMULATOR

        ENTRY   0003 
OTH_PAUSE:              
        bsr     GET_KEY
        cmp.b   #13,d7
        bne.s   OTH_PAUSE
        rts

***************************** INITIALIZE CHARACTER BUFFER

Initialize_Character_Buffer:
        lea     4(sp),a5
        move.l  a5,char_data         

        move.w  #1,-(sp)                ; Set font to normal
        jsr     tios::FontSetSys
        addq.w  #2,sp

        moveq   #0,d6
loop_store_big_chars:
        moveq   #0,d0
        moveq   #0,d1
        lea     string_data(pc),a0
        move.b  d6,(a0)
        bsr     Display_String
                             
        lea     LCD_MEM,a0
        moveq   #7,d0
loop_copy_big_char:
        move.b  (a0),(a5)+
        clr.b   (a0)
        lea     30(a0),a0
        dbra    d0,loop_copy_big_char
        
        addq.w  #1,d6
        cmp.w   #128,d6
        bne.s   loop_store_big_chars

        move.w  #0,-(sp)                ; Set font to normal
        jsr     tios::FontSetSys
        addq.w  #2,sp

        moveq   #0,d6
loop_store_s_chars:
        moveq   #0,d0
        moveq   #0,d1
        lea     string_data(pc),a0
        move.b  d6,(a0)
        bsr     Display_String
                             
        lea     LCD_MEM,a0
        moveq   #7,d0
loop_copy_s_char:
        move.b  (a0),(a5)+
        clr.b   (a0)
        lea     30(a0),a0
        dbra    d0,loop_copy_s_char
        
        addq.w  #1,d6
        cmp.w   #128,d6
        bne.s   loop_store_s_chars

off_screen:
        rts

char_data:
        dc.l    0

string_data:
        dc.b    " ",0

***************************** TX_CHARPUT CALL SIMULATOR

string: dc.b    ' ',0

        ENTRY   0004 
TX_CHARPUT:
        lea     OFF8+$c(a0),a2          ; Load coordinates and check if onscreen
        moveq   #0,d0
        move.b  (a2),d0
        cmp.w   #8,d0                   ; D0 = Y
        bge     off_screen
        moveq   #0,d1
        move.b  1(a2),d1
        cmp.w   #21,d1                  ; D1 = X
        bge     off_screen

        addq.b  #1,1(A2)                ; Advance cursor coordinates
        cmp.b   #21,1(a2)
        bne.s   no_wrap
        clr.b   1(a2)
        addq.b  #1,(a2)
no_wrap:

        lea     OFFF+$c00(a0),a2        ; Calculate screen address (TI-85)
        lsl.w   #7,d0
        add.w   d0,a2
        mulu    #6,d1
        move.w  d1,d0
        lsr.w   #4,d0
        add.w   d0,d0
        add.w   d0,a2

        move.l  char_data(pc),a3        ; Calculate address in char buffer
        ext.w   d7
        bclr    #7,d7
        lsl.w   #3,d7
        add.w   d7,a3

        movem.w d5/d6,-(sp)
        moveq   #7,d6
        move.w  #%1111111100000011,d5
        bsr.s   Byte_Sprite
        movem.w (sp)+,d5/d6
        rts

***************************** STANDARD CHARACTER RENDERING

Byte_Sprite:                            ; Byte sprite put
                                        ; D1 = bit shift (0..15)
                                        ; A3 -> sprite data
                                        ; A2 -> destination
                                        ; D6 = height - 1
                                        ; D5 = bit mask
        and.w   #15,d1
        cmp.w   #8,d1
        beq.s   middle
        bgt.s   right_side

        neg.w   d1
        addq.w  #8,d1
        rol.w   d1,d5
loop_bcl:
        moveq   #0,d0
        move.b  (a3)+,d0
        rol.w   d1,d0
        and.w   d5,(a2)
        or.w    d0,(a2)
        lea     16(a2),a2
        dbra    d6,loop_bcl
        rts

middle: addq.w  #1,a2
loop_bcm:
        and.b   d5,(a2)
        move.b  (a3)+,d0
        or.b    d0,(a2)
        lea     16(a2),a2
        dbra    d6,loop_bcm
        rts

right_side:
        subq.w  #8,d1
        ext.l   d5
        swap    d5
        ror.l   d1,d5
loop_bcr:
        moveq   #0,d0
        move.b  (a3)+,d0
        swap    d0
        ror.l   d1,d0
        and.l   d5,(a2)
        or.l    d0,(a2)
        lea     16(a2),a2
        dbra    d6,loop_bcr
        rts

***************************** D_ZT_STR CALL SIMULATOR

        ENTRY   0005 
D_ZT_STR:
        __ADDR  4
        addq.w  #1,d4
        move.b  (a4),d7
        beq.s   rts1
        bsr     TX_CHARPUT
        bra.s   D_ZT_STR

***************************** GET_KEY CALL SIMULATOR

        ENTRY   0006
GET_KEY:
        lea     key_read,a6
        move.b  (a6),d7
        clr.b   (a6)
rts1:   rts

***************************** OUT INSTRUCTION

        ENTRY   0007 
        cmp.b   #1,d1
        beq.s   outport1
        rts
outport1:
        move.b  d7,keymask
        rts

***************************** IN INSTRUCTION

        ENTRY   0008 
        cmp.b   #1,d1
        beq.s   inport1
        rts

inport1:
        lea     key_data_new(pc),a6
        movem.w d2-d4,-(sp)
        move.b  keymask,d0          ;
        moveq   #6,d1               ; D1 = 6 - row of TI-85 matrix
        moveq   #-1,d7              ; D7 = returned data
in1l:   asr.b   #1,d0               ; Test mask 
        bcs.s   noread
        bsr     read_row            ; If 0, read this row
noread: dbra    d1,in1l
        movem.w (sp)+,d2-d4
        rts

read_row:
        moveq   #6,d2
        sub.w   d1,d2
        asl.w   #3,d2               ; D2 = row of equiv. table
        lea     keyconvtable+8(pc,d2.w),a5
        moveq   #7,d3               ; D3 = bit in TI-85 matrix
loop_read:
        move.b  -(a5),d4             
        and.w   #$f,d4              ; D4 = row number
        move.b  0(a6,d4.w),d2       ; D2 = TI-92 key data
        move.b  (a5),d4
        lsr.w   #4,d4               ; D4 = bit number
        btst    d4,d2
        bne.s   notset
        bclr    d3,d7               ; If 0, clear TI-85 bit
notset: dbra    d3,loop_read
        rts

keymask:
        dc.w    -1
                     
 ; Key equivalence table - Data from bits 0 to 7 in each TI-85 row,
 ; with row 0 first.  High nybble of each byte is the TI-92 bit, low
 ; nybble is the TI-92 row.

        IFND    TI89 
keyconvtable:
        dc.b    $70,$40,$60,$50,$78,$78,$78,$78
        dc.b    $19,$48,$09,$77,$05,$06,$57,$78
        dc.b    $79,$71,$72,$73,$64,$75,$67,$78
        dc.b    $69,$61,$62,$63,$54,$65,$30,$08
        dc.b    $59,$51,$52,$53,$32,$55,$21,$14
        dc.b    $38,$03,$74,$12,$56,$28,$24,$29
        dc.b    $47,$49,$42,$44,$46,$00,$68,$58
keyconvtable_end:
        dc.b    $78,$78,$78,$78,$78,$78,$78,$78
        ENDIF

        IFD     TI89
keyconvtable:
        dc.b    $20,$10,$30,$00,$76,$76,$76,$76
        dc.b    $01,$11,$21,$31,$41,$51,$61,$76
        dc.b    $02,$12,$22,$32,$43,$52,$05,$76
        dc.b    $03,$13,$23,$33,$44,$53,$66,$62
        dc.b    $04,$14,$24,$34,$25,$54,$35,$55
        dc.b    $76,$15,$42,$50,$63,$45,$60,$70
        dc.b    $71,$72,$73,$74,$75,$40,$06,$64
keyconvtable_end:
        dc.b    $76,$76,$76,$76,$76,$76,$76,$76
        ENDIF

***************************** FIND_PIXEL CALL SIMULATOR

        ENTRY   0009 
        move.b  d2,d4                   ; D4 (L) = Y coordinate
        move.w  d2,d0
        asr.w   #8,d0                   ; D0 = X coordinate
        move.b  d0,d1
        not.w   d1
        and.w   #7,d1                   ; D1 = bit number
        moveq   #0,d7
        bset    d1,d7                   ; D7 (A) = bit mask
        lsr.w   #3,d0                   ; D0 = X offset
        not.w   d4
        and.w   #$3f,d4                 ; D4 (HL) = real Y coordinate
        lsl.w   #4,d4                   ; D4 (HL) = Y offset
        add.w   d0,d4                   ; D4 (HL) = pixel offset
        and.w   #$3ff,d4
        rts

***************************** LD_HL_MHL CALL SIMULATOR

        ENTRY   000A 
        __ADDR  4
        move.b  (a4)+,d0
        move.b  (a4),d4
        lsl.w   #8,d4
        move.b  d0,d4
        rts

***************************** D_LM_STR CALL SIMULATOR

        ENTRY   000B 
        __ADDR  4
        move.w  d2,d0
        lsr.w   #8,d0
        subq.w  #1,d0
lmd:    move.b  (a4)+,d7
        move.w  d0,-(sp)
        bsr     M_CHARPUT
        move.w  (sp)+,d0
        dbra    d0,lmd
rts41:  rts

***************************** M_CHARPUT CALL SIMULATOR

        ENTRY   000C 
M_CHARPUT:
        lea     OFF8+$334(a0),a2          ; Load coordinates and check if onscreen
        moveq   #0,d0
        move.b  (a2),d0                 ; D0 = y
        cmp.w   #58,d0
        bge     rts41
        moveq   #0,d1
        move.b  -(a2),d1                ; D1 = x
        cmp.w   #124,d1
        bge     rts41
    
        addq.b  #4,(A2)                 ; Advance cursor coordinates

        lea     OFFF+$c00(a0),a2        ; Calculate screen address (TI-85)
        lsl.w   #4,d0
        add.w   d0,a2
        move.w  d1,d0
        lsr.w   #4,d0
        add.w   d0,d0
        add.w   d0,a2

        move.l  char_data(pc),a3        ; Calculate address in char buffer
        ext.w   d7
        bset    #7,d7
        lsl.w   #3,d7
        add.w   d7,a3

        movem.w d5/d6,-(sp)
        moveq   #6,d6
        move.w  #%1111111100001111,d5
        bsr     Byte_Sprite
        movem.w (sp)+,d5/d6
        rts

***************************** LOAD A FROM R REGISTER

        ENTRY   000D 
        move.l  a0,-(sp)
        move.l  a1,-(sp)
        move.w  d2,-(sp)
    IFD FARGO
        jsr     tios::rand
    ENDIF
    IFD TI92P
        move.w  #256,d0
        jsr     userlib@0001
    ENDIF
        move.b  d0,d7
        move.w  (sp)+,d2
        move.l  (sp)+,a1
        move.l  (sp)+,a0
rts3:   rts

***************************** D_ZM_STR CALL SIMULATOR

        ENTRY   000E
D_ZM_STR:
        __ADDR  4
        addq.w  #1,d4
        move.b  (a4),d7
        beq.s   rts3        
        bsr     M_CHARPUT
        bra.s   D_ZM_STR

***************************** UNPACK_HL CALL SIMULATOR

        ENTRY   000F 
        ext.l   d4
        divu    #10,d4
        swap    d4
        move.b  d4,d7
        swap    d4
        rts

***************************** CP_HL_DE CALL SIMULATOR

        ENTRY   0010 
        cmp.w   d3,d4
        move.w  sr,(a0)
        rts

***************************** D_HL_DECI CALL SIMULATOR

format: dc.b    "%5u",0

        ENTRY   0011 
        move.l  a0,-(sp)
        move.l  a1,-(sp)
        move.w  d2,-(sp)
        move.w  d4,-(sp)
        pea     format(pc)
        pea     OFF8+$c6(a0)
        jsr     tios::sprintf
        lea     10(sp),sp
        move.w  #$80c6,d4
        move.w  (sp)+,d2
        move.l  (Sp)+,a1
        move.l  (sp)+,a0
        bra     D_ZT_STR

***************************** OTH_EXIT CALL SIMULATOR

        ENTRY   0012
OTH_EXIT:
exit:   lea     $12345678,a7
        moveq   #0,d0
        trap    #1
        move.w  #$b2,$600016            ; Restore interrupt
        move.l  old_int5,$74
        rts

***************************** OTH_ARROW CALL SIMULAOTR

        ENTRY   0013 
        move.b  #%10111110,keymask
        bra     inport1

***************************** OTH_CLEAR CALL SIMULATOR

        ENTRY   0014 
        __ADDR  4 
        add.w   d2,d4
        move.w  d4,d3
        addq.w  #1,d3
occsl:  sf      (a4)+
        dbra    d2,occsl
        rts

***************************** UNPACK_HL+2 CALL SIMULATOR

        ENTRY   0015 
        ext.l   d4
        move.b  d7,d1
        ext.w   d1
        beq.s   divbyzero
        divu    d1,d4
        swap    d4
        move.b  d4,d7
        swap    d4
rts2:   rts

divbyzero:
        moveq   #-1,d7
        moveq   #-1,d4
        rts

***************************** LDIR INSTRUCTION

        ENTRY   0016

        __ADDR  4
        __ADDR  3
        add.w   d2,d4
        add.w   d2,d3
        move.w  d2,d1
        lsr.w   #4,d1
        beq.s   sldi

        and.w   #15,d2
        subq.w  #1,d1
lldi:   move.b  (A4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        dbra    d1,lldi
                        
sldi:   add.w   d2,d2
        neg.w   d2
        jmp     lditable(pc,d2.w)

        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
        move.b  (a4)+,(a3)+
lditable:
        moveq   #0,d2
        rts

***************************** LDDR INSTRUCTION

        ENTRY   0017

        __ADDR  4
        __ADDR  3
        cmp.b   (a3)+,(a4)+
        sub.w   d2,d4
        sub.w   d2,d3
        move.w  d2,d1
        lsr.w   #4,d1
        beq.s   sldd

        and.w   #15,d2
        subq.w  #1,d1
lldd:   move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        dbra    d1,lldd
                        
sldd:   add.w   d2,d2
        neg.w   d2
        jmp     lddtable(pc,d2.w)

        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
        move.b  -(a4),-(a3)
lddtable:
        moveq   #0,d2
        subq.l  #1,a4
        subq.l  #1,a3
        rts

***************************** MISC. ROUTINES
            
Clear_Screen:
        lea     $4440,a0                ; Clear the screen
        moveq   #0,d1                   
        move.l  #(3840/4)-1,d0
cls_loop:
        move.l  d1,(a0)+
        dbra    d0,cls_loop
        rts

Print_Messages:                         ; Display a sequence of strings
        moveq   #0,d1
        addq.w  #8,d4
        move.w  d4,d0
        lea     -1(a2),a0
        bsr     Display_String
loop_end_str:
        tst.b   (a2)+
        bne.s   loop_end_str
        tst.b   (a2)+
        bne.s   Print_Messages
        rts

Display_String:                         ; Display (A0) at (D1,D0)
        move.w  #4,-(sp)     
        move.l  a0,-(sp)
        move.w  d0,-(sp)
        move.w  d1,-(sp)
        jsr     tios::DrawStrXY
        lea     10(sp),sp
        rts

***************************** DATA

data_buffer:
        dc.l    0
prog_code:
        dc.l    0

keyboard:
        dc.l    tios::kb_vars+$1c

old_int5:
        dc.l    0

        dc.l    0
tbuf:   dc.l    0
        dc.l    0

count1: dc.w    0
count2: dc.w    0

warning:
        dc.b    '   WARNING: This program was',0
        dc.b    'automatically converted to',0
        dc.b    '68K code by Source Guru!',0

        dc.b    '   The conversion process is',0
        dc.b    'not completely reliable, so',0
        dc.b    'you should test the program',0
        dc.b    'thoroughly before deciding',0
        dc.b    'to trust it.  Refer to the',0
        dc.b    'Source Guru documentation',0
        dc.b    'for more information.',0

        dc.b    '   Press 3 to continue, or',0
        dc.b    'any other key to exit.',0,0

    IFD FARGO
_library:
    IFD MEMSLOW
        dc.b    'ti85lib2',0
    ENDIF
    IFD MEMFAST
        dc.b    'ti85lib3',0
    ENDIF
    ENDIF
