#include <stdio.h>

#include "srcguru.h"

void output_debug()
{
    source_item* current;
    current = z80_source;

    fprintf(outfile, "Begin parser debugging output:\n");

    while (current) {
        switch (current->type) {
            case ITEM_LINE:
                fprintf(outfile, "   Line:");
                fprintf(outfile, "%s\n", txt);
                break;
            case ITEM_LABEL:
                fprintf(outfile, "  Label:");
                fprintf(outfile, "%s\n", txt);
                break;
            case ITEM_COMMENT:
                fprintf(outfile, "Comment:");
                fprintf(outfile, "%s\n", txt);
                break;
            case ITEM_INSTRUCTION:
                fprintf(outfile, "Instruc: %s - Arg1 %s - Arg2 %s\n", txt, a1, a2);
                break;
            case ITEM_DIRECTIVE:
                fprintf(outfile, "Directv: %s", txt);
                fprintf(outfile, " - Arg %s\n", a1);
                break;
            case ITEM_CONSTNUM:
                fprintf(outfile, "     db: %s\n", txt);
                break;
            case ITEM_CONSTSTR:
                fprintf(outfile, "     db: \"%s\"\n", txt);
                break;
            case ITEM_MACROCALL:
                fprintf(outfile, "  Macro: %s", txt);
                fprintf(outfile, "- Arg %s\n", a1);
                break;
            case ITEM_CONSTWORD:
                fprintf(outfile, "     dw: %s\n", txt);
                break;
            case ITEM_EQUATE:
                fprintf(outfile, "  Equate:");
                fprintf(outfile, "Symbol %s - Value %s\n", txt, a1);
                break;
            default:
                fprintf(outfile, "?????");
        }
        current = current->next;
    }
}
