#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#define MODE_NORMAL 0
#define MODE_DEBUG 1
#define MODE_CLEANUP 2

#define ITEM_LINE 0
#define ITEM_LABEL 1
#define ITEM_COMMENT 2
#define ITEM_INSTRUCTION 3
#define ITEM_DIRECTIVE 4
#define ITEM_CONSTNUM 5
#define ITEM_CONSTSTR 6
#define ITEM_MACROCALL 7
#define ITEM_CONSTWORD 8
#define ITEM_EQUATE 9

typedef struct item_struct {
    struct item_struct* next;
    struct item_struct* prev;
    int type;
    char* maintext;
    char* arg1;
    char* arg2;
    int sets_flags;
    int leaves_flags;
    int uses_flags;
    int gets_flags;
    int do_save_flags;
    int *addruse;
    int *addrset;
} source_item;

#define SF_NONE 0
#define SF_CARRY 1
#define SF_ZERO 2
#define SF_ALL 3

#define txt current->maintext
#define a1 current->arg1
#define a2 current->arg2
#define eq(s1,s2) !(stricmp(s1,s2))
#define eqc(s1,s2) !(strcmp(s1,s2))

int stricmp(char* s1, char* s2);
int strnicmp(char* s1, char* s2, int n);

source_item* _add_item(int type, char* maintext, char* arg1, char* arg2, source_item* prev, source_item* next);
void add_item(int type, char* maintext, char* arg1, char* arg2); 
void delete_item(source_item *item);

FILE* infile;
FILE* outfile;

#define MAX_LINE 1000

char empty[1];
int program_mode;
int show_original;
int exact_stack;
source_item* z80_source;
source_item* last_item;
int smc1;
int smc2;
int smc3;
int no_flags;
int turbo;
int zkart3dhack;
