#include "srcguru.h"

#include "hash.h"

#include "symbols.h"

hash_item **symbol_hash;
hash_item **old_sh;

void init_symbols()
{
    symbol_hash = new_hash_table(256);
    if (turbo) {
        add_symbol(ST_ROMCALL, "CLEARLCD", "ti85lib3@0002", NULL);
        add_symbol(ST_ROMCALL, "OTH_PAUSE", "ti85lib3@0003", NULL);
        add_symbol(ST_ROMCALL, "TX_CHARPUT", "ti85lib3@0004", NULL);
        add_symbol(ST_ROMCALL, "D_ZT_STR", "ti85lib3@0005", NULL);
        add_symbol(ST_ROMCALL, "GET_KEY", "ti85lib3@0006", NULL);
        add_symbol(ST_ROMCALL, "FIND_PIXEL", "ti85lib3@0009", NULL);
        add_symbol(ST_ROMCALL, "LD_HL_MHL", "ti85lib3@000A", NULL);
        add_symbol(ST_ROMCALL, "D_LM_STR", "ti85lib3@000B", NULL);
        add_symbol(ST_ROMCALL, "M_CHARPUT", "ti85lib3@000C", NULL);
        add_symbol(ST_ROMCALL, "D_ZM_STR", "ti85lib3@000E", NULL);
        add_symbol(ST_ROMCALL, "UNPACK_HL", "ti85lib3@000F", NULL);
        add_symbol(ST_ROMCALL, "CP_HL_DE", "ti85lib3@0010", NULL);
        add_symbol(ST_ROMCALL, "D_HL_DECI", "ti85lib3@0011", NULL);
        add_symbol(ST_ROMCALL, "OTH_EXIT", "ti85lib3@0012", NULL);
        add_symbol(ST_ROMCALL, "OTH_ARROW", "ti85lib3@0013", NULL);
        add_symbol(ST_ROMCALL, "OTH_CLEAR", "ti85lib3@0014", NULL);
        add_symbol(ST_ROMCALL, "UNPACK_HL+2", "ti85lib3@0015", NULL);
    } else {
        add_symbol(ST_ROMCALL, "CLEARLCD", "ti85lib2@0002", NULL);
        add_symbol(ST_ROMCALL, "OTH_PAUSE", "ti85lib2@0003", NULL);
        add_symbol(ST_ROMCALL, "TX_CHARPUT", "ti85lib2@0004", NULL);
        add_symbol(ST_ROMCALL, "D_ZT_STR", "ti85lib2@0005", NULL);
        add_symbol(ST_ROMCALL, "GET_KEY", "ti85lib2@0006", NULL);
        add_symbol(ST_ROMCALL, "FIND_PIXEL", "ti85lib2@0009", NULL);
        add_symbol(ST_ROMCALL, "LD_HL_MHL", "ti85lib2@000A", NULL);
        add_symbol(ST_ROMCALL, "D_LM_STR", "ti85lib2@000B", NULL);
        add_symbol(ST_ROMCALL, "M_CHARPUT", "ti85lib2@000C", NULL);
        add_symbol(ST_ROMCALL, "D_ZM_STR", "ti85lib2@000E", NULL);
        add_symbol(ST_ROMCALL, "UNPACK_HL", "ti85lib2@000F", NULL);
        add_symbol(ST_ROMCALL, "CP_HL_DE", "ti85lib2@0010", NULL);
        add_symbol(ST_ROMCALL, "D_HL_DECI", "ti85lib2@0011", NULL);
        add_symbol(ST_ROMCALL, "OTH_EXIT", "ti85lib2@0012", NULL);
        add_symbol(ST_ROMCALL, "OTH_ARROW", "ti85lib2@0013", NULL);
        add_symbol(ST_ROMCALL, "OTH_CLEAR", "ti85lib2@0014", NULL);
        add_symbol(ST_ROMCALL, "UNPACK_HL+2", "ti85lib2@0015", NULL);
    }
}

void add_label(char *name)
{
    char name2[MAX_LINE] = "RA_";
    if (name[strlen(name) - 1] == ':')
        name[strlen(name) - 1] = 0;
    strcat(name2, name);
    add_item(ITEM_LABEL, name, "", "");
    add_symbol(ST_LABEL, name, name2, last_item);
}

void hash_dump()
{
    int x;
    hash_item *y;
    printf("-------------------------------- HASH DUMP\n");
    for (x = 0; x < HT_SIZE; x++)
        if (y = symbol_hash[x]) {
            printf("Entries in slot %d\n", x);
            while (y) {
                printf("<%s>=<%s>\n", y->name, y->value);
                y = y->next;
            }
        }
}

void add_symbol(int type, char *name, char *value, void *misc)
{
    hash_item *p;
    p = get_symbol(name);
    if (p)
        return;

    if (zkart3dhack)
        if (eq(name, "marker")) {
            delete_item(last_item);
            add_label("marker2");
            hash_add(type, "marker", "marker2+1", misc, symbol_hash);
            add_item(ITEM_EQUATE, "marker", "marker2+1", "");
            return;
        }
    hash_add(type, name, value, misc, symbol_hash);
}

void add_equate(char *name, char *invalue)
{
    char value[MAX_LINE] = "";
    static int count = 0;

    invalue++;
    if (*invalue == 0)
        return;

    if ((!(strnicmp(invalue, "*+", 2))) ||
        (!(strnicmp(invalue, "$+", 2))) ||
        (!(strnicmp(invalue, "*-", 2)))) {
        sprintf(value, "__pcrl_%d", count++);
        add_label(value);
        strcat(value, invalue + 1);
    } else
        strcpy(value, invalue);

    add_item(ITEM_EQUATE, name, value, empty);
    add_symbol(ST_EQUATE, name, value, NULL);
}

hash_item* get_symbol(char *name)
{
    return hash_get(name, symbol_hash);
}
